apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ releasebell_name }}
  name: {{ releasebell_name }}
  namespace: {{ namespace }}
spec:
{% if not do_hpa or has_dc.resources | length == 0 %}
  replicas: {{ releasebell_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ releasebell_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ releasebell_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ releasebell_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ releasebell_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ releasebell_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ releasebell_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ releasebell_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ releasebell_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: FORKS
          value: "1"
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LEMON_PORTAL
{% if do_lemon %}
          value: {{ lemon_manager }}
{% else %}
          value: ""
{% endif %}
{% if releasebell_db_type == 'percona' %}
        - name: MYSQL_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rbpc_name }}
        - name: MYSQL_HOST
          value: {{ rbpc_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rbpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rbpc_name }}
{% elif releasebell_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ rbms_name }}
        - name: MYSQL_HOST
          value: {{ rbms_name }}
        - name: MYSQL_PASS
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ rbms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ rbms_name }}
{% endif %}
        - name: NO_K8S_ENV
          value: pm2-is-stupid
        - name: NODE_ENV
          value: production
        - name: NODE_EXTRA_CA_CERTS
{% if (do_ldap or do_lemon or smtps_address | default(False)) and k8s_flavor == 'kubernetes' %}
          value: /certs/ca.crt
{% else %}
          value: ""
{% endif %}
{% if do_ldap %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: "{% if ldaps_address | default(False) and skip_ldap_verify | default(False) %}0{% endif %}"
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
{% if not do_lemon %}
          value: cn=releasebell,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: releasebell-password
              name: {{ ldap_secret_name }}
{% else %}
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
{% endif %}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ releasebell_ldap_user_objectclass }}
{% endif %}
{% else %}
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: ""
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
{% endif %}
        - name: RELEASEBELL_API_HOSTNAME
{% if do_lemon %}
          value: {{ releasebell_fqdn }}
        - name: RELEASEBELL_LLNG_BIND_PW
          valueFrom:
            secretKeyRef:
              key: ssoapp-password
              name: {{ ldap_secreet_name }}
{% else %}
          value: ""
        - name: RELEASEBELL_LLNG_BIND_PW
          value: ""
{% endif %}
        - name: MAIL_FROM
          value: releasebell@{{ root_domain }}
        - name: MAIL_SMTP_SERVER
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: MAIL_SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: MAIL_SMTP_SECURE
          value: ""
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: MAIL_SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: MAIL_SMTP_SECURE
          value: "true"
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: MAIL_SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: MAIL_SMTP_SECURE
          value: ""
{% else %}
          value: ""
        - name: MAIL_SMTP_PORT
          value: ""
        - name: MAIL_SMTP_SECURE
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='releasebell'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='releasebell'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 10
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /api/v1/status
            port: 3000
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: releasebell
        ports:
        - containerPort: 3000
        readinessProbe:
          failureThreshold: 5
          httpGet:
            path: /api/v1/status
            port: 3000
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ releasebell_cpu_limit }}"
            memory: "{{ releasebell_memory_limit }}"
          requests:
            cpu: "{{ releasebell_cpu_request }}"
            memory: "{{ releasebell_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 10
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 3000
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False) or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
        volumeMounts:
        - mountPath: /certs
          name: pkiconf
{% if (do_ldap or do_lemon) %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ releasebell_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if do_ldap or do_lemon %}
      volumes:
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False) or airbrake_host | default(False)) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if airbrake_host | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: airbrake-ca.crt
{% if errbit_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtp_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='releasebell'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - releasebell
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='releasebell'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
